package com.ibm.etools.iseries.examples.jformatted.JFormattedBeans;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 2000 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if IBM has been
// advised of the possibility of such damages.
//
// ************************************************************************
//
// This sample program demonstrates the use of JFormattedTextField,
// JFormattedComboBox, JFormattedLabel, JFormattedTable, JFormattedTableColumn,
// JFormattedTextFieldCellEditor, JFormattedComboBoxCellEditor
// and JFormattedLabelRenderer.
//
// @RJ 1 10/29/02 - icons not found when launched from the wizard - add monitor for size
// ************************************************************************
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.text.Document;

import com.ibm.etools.iseries.ui.AS400FieldModel;
import com.ibm.etools.iseries.ui.Attributes;
import com.ibm.etools.iseries.ui.ComparisonRangeValidator;
import com.ibm.etools.iseries.ui.DataAttributes;
import com.ibm.etools.iseries.ui.EditcodeEditwordFormatter;
import com.ibm.etools.iseries.ui.EditmaskAttributes;
import com.ibm.etools.iseries.ui.FieldModel;
import com.ibm.etools.iseries.ui.Formatter;
import com.ibm.etools.iseries.ui.JFormattedComboBox;
import com.ibm.etools.iseries.ui.JFormattedComboBoxCellEditor;
import com.ibm.etools.iseries.ui.JFormattedLabel;
import com.ibm.etools.iseries.ui.JFormattedLabelCellRenderer;
import com.ibm.etools.iseries.ui.JFormattedTable;
import com.ibm.etools.iseries.ui.JFormattedTableColumn;
import com.ibm.etools.iseries.ui.JFormattedTextField;
import com.ibm.etools.iseries.ui.JFormattedTextFieldCellEditor;
import com.ibm.etools.iseries.ui.UpperCaseDocument;
import com.ibm.etools.iseries.ui.Validator;


public class JFormattedBeans extends JFrame 
{


	private JFormattedTable 	  itemTable;
	private DefaultTableModel     itemModel;
	private JPanel 			   	  panel1;
	private JLabel				  h1, h2, h3, L4, L5, L6, L7, L8, lstatus;
	private JFormattedTextField   accountNo;
	private JFormattedLabel 	  totalAmt;
	private JFormattedComboBox    bankAcc;
	private JScrollPane 		  scrollPane;
	private JFormattedTableColumn itemColumn = null;
	private JFormattedTableColumn dateColumn = null;
	private JFormattedTableColumn priceColumn = null;
	private JFormattedTableColumn quantityColumn = null;
	private JFormattedTableColumn amountColumn = null;


	// Header of table columns
	public final String[] columnNames = {"Item","Shipping Date", "Price","Quantity","Amount"};
	String path1  = java.lang.System.getProperty("user.dir")+
					java.lang.System.getProperty("file.separator")+
					"com"+
					java.lang.System.getProperty("file.separator")+
					"ibm"+
					java.lang.System.getProperty("file.separator")+
					"etools"+
				    java.lang.System.getProperty("file.separator")+
				    "iseries"+
				    java.lang.System.getProperty("file.separator")+
				    "examples"+
				    java.lang.System.getProperty("file.separator")+
				    "jformatted"+
				    java.lang.System.getProperty("file.separator")+
				    "JFormattedBeans"+
				    java.lang.System.getProperty("file.separator");

	// Items in the combo box
	public final Icon[] items = new Icon[] 
	{
		new ImageIcon(getToolkit().getImage(path1+"forsale1.gif")),
		new ImageIcon(getToolkit().getImage(path1+"book.gif")),
		new ImageIcon(getToolkit().getImage(path1+"sports.gif")),
		new ImageIcon(getToolkit().getImage(path1+"travel1.gif")),
		new ImageIcon(getToolkit().getImage(path1+"butnews1.gif")),
		new ImageIcon(getToolkit().getImage(path1+"None.gif"))
	};


	// Shipping Dates in the combo box
	public final String[] dates = {"09061999","09201999","10111999","10251999","11081999","11221999","12061999","12201999"};
	
	// Price of each item
	public final String[] prices = { "100.00", "59.90", "154.90", "979.00", "1", "0" };


	// Data appear in the table
	public Object[][] data = 
	{
		{	items[5], "09061999", "0", "0", "0.00"},
		{	items[5], "09061999", "0", "0", "0.00"},
		{	items[5], "09061999", "0", "0", "0.00"},
		{	items[5], "09061999", "0", "0", "0.00"},
		{	items[5], "09061999", "0", "0", "0.00"}
	};


	// Account numbers
	private final String[] acc = { "0011238769","4018274905","9304857602","1829304956" };


/*
 * Constructor of the class JFormattedBeansSample.
 * It creates all the components and add them onto a JFrame window
 * using GridBagLayout.
 */
public JFormattedBeans() 
{
	setTitle("JFormatted beans");
	setBackground(new Color(java.awt.SystemColor.window.getRGB()));
	setResizable(true);


	JPanel panel1=new JPanel(new GridBagLayout());
	panel1.setLayout(new GridBagLayout());


	h1=new JLabel("This sample demonstrates the use of JFormattedTextField, JFormattedComboBox, JFormattedLabel, ");
	Font font = h1.getFont();
	Font newfont = new Font(font.getFamily(),java.awt.Font.PLAIN, font.getSize());
	h1.setFont(newfont);
	h2=new JLabel("JFormattedTable, JFormattedTableColumn, JFormattedLabelCellRenderer, JFormattedTextFieldCellEditor,");
	h2.setFont(newfont);
	h3=new JLabel("and JFormattedComboBoxCellEditor.");
	h3.setFont(newfont);
	
	L4=new JLabel("Account Number (e.g. AA/999-9999):");
	L4.setForeground(Color.black);
	
	L5=new JLabel("Select items to purchase");
	L5.setForeground(Color.black);


	L6=new JLabel("Total Amount: ");
	L6.setForeground(Color.black);


	L7=new JLabel("Debit amount from Bank Account:");
	L7.setForeground(Color.black);


	L8=new JLabel(" ");
	L8.setForeground(Color.blue);
	L8.setPreferredSize(new Dimension(600,25));
		
	lstatus=new JLabel("");
	lstatus.setPreferredSize(new Dimension(600,25));
	lstatus.setForeground(Color.red);
	
	// Account number must be in range from AA/000-0000 to ZZ/999-9999,
	// The first two letters are converted uppercase.
	Attributes dataAttr1    = new DataAttributes(DataAttributes.DATATYPE_CHARACTER, 9);
	Validator  val1         = new ComparisonRangeValidator(dataAttr1, 
								ComparisonRangeValidator.VALIDITYTYPE_RANGE,
								ComparisonRangeValidator.COMPARISON_NONE,
								null,"AA0000000", "ZZ9999999");
	Document keyVer1 = new UpperCaseDocument(dataAttr1);
	accountNo = new JFormattedTextField(new AS400FieldModel(dataAttr1, null, val1, keyVer1));
	Attributes editmaskAttr1 = new EditmaskAttributes("  /   -    ", "  &   &    ");
	try
	{
		accountNo.setEditmaskAttributes(editmaskAttr1);
	}
	catch(Exception e1)
	{
		System.out.println("Invalid editmask attribute");
	}
	accountNo.setPreferredSize(new Dimension(150,25));


	// Create item table
	createItemTable();


	// Add components to panel1
	addItem(panel1,h1,0,0,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addItem(panel1,h2,0,1,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addItem(panel1,h3,0,2,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,20,1);
	addItem(panel1,L4,0,5,2,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);		
	addItem(panel1,accountNo,2,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,10,1);
	addItem(panel1,L5,0,7,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addItem(panel1,scrollPane,0,8,10,10,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addItem(panel1,L6,0,20,2,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addItem(panel1,totalAmt,2,20,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,10,1);
	addItem(panel1,L7,0,22,1,2,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addItem(panel1,bankAcc,2,22,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,10,1);
	addItem(panel1,L8,0,24,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,10,1);
	addItem(panel1,lstatus,0,25,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,10,1);


	
	getContentPane().add(panel1);	


}
// add Component to JPanel, using passed GridbagLayout - related values
private void addItem(JPanel jp,Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) 
{
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
		
	// Set constraint for the component
	((GridBagLayout)jp.getLayout()).setConstraints(c, gbc);
	jp.add(c);
}
/**
 * Create the item table which is a JFormattedTable
 */
public void createItemTable() 
{
	// Create item table
	itemModel = new DefaultTableModel(data, columnNames);
	itemTable = new JFormattedTable(itemModel);
	itemTable.setPreferredScrollableViewportSize(new Dimension(600, 250));

	// @RJ icons not found in RUN directory anymore,
	// but are found when launched from workspace package
	try 
	{
	itemTable.setRowHeight(items[0].getIconHeight());
	}
	catch (Exception e)
	{
	itemTable.setRowHeight(30);
		e.printStackTrace();
	}
	// @RJ end



	itemTable.setAutoResizeMode( JFormattedTable.AUTO_RESIZE_ALL_COLUMNS);
	
	// Create the scroll pane and add the table to it. 
	scrollPane = new JScrollPane(itemTable);


	// get columns
	try 
	{
		itemColumn = (JFormattedTableColumn)itemTable.getColumn("Item");
		dateColumn  = (JFormattedTableColumn)itemTable.getColumn("Shipping Date");
		priceColumn  = (JFormattedTableColumn)itemTable.getColumn("Price");
		quantityColumn  = (JFormattedTableColumn)itemTable.getColumn("Quantity");
		amountColumn  = (JFormattedTableColumn)itemTable.getColumn("Amount");
	}
	catch (Exception e)
	{
		e.printStackTrace();
	}
	
	setUpItemColumn(itemColumn);
	setUpDateColumn(dateColumn);
	setUpPriceColumn(priceColumn);
	setUpQuantityColumn(quantityColumn);
	setUpAmountColumn(amountColumn);
	
	// Total Amount is a JFormattedLabel field
	Attributes dataAttr2 = new DataAttributes(DataAttributes.DATATYPE_NUMERIC, 12, 2, '.');
	Formatter formatter2 = new EditcodeEditwordFormatter(dataAttr2, '1', EditcodeEditwordFormatter.EDITCODEPARM_CURRENCY, null);
	totalAmt = new JFormattedLabel(new AS400FieldModel(dataAttr2, formatter2));
	totalAmt.setPreferredSize(new Dimension(150,19));
	try
	{
		totalAmt.setUnformattedText("0.00");
	}
	catch(Exception e2)
	{
		System.out.println("Invalid Total Amount 0");
	}


	// Bank Account JFormattedComboBox field
	Attributes dataAttr3     = new DataAttributes(DataAttributes.DATATYPE_NUMERIC, 10);
	Formatter formatter3 = new EditcodeEditwordFormatter(dataAttr3, '0', EditcodeEditwordFormatter.EDITCODEPARM_NONE, "   -   -    ");
	bankAcc = new JFormattedComboBox(acc, new AS400FieldModel(dataAttr3, formatter3));
	bankAcc.setPreferredSize(new Dimension(150,25));
	bankAcc.addItemListener(new ItemListener() 
	{
		public void itemStateChanged(ItemEvent evt) 
		{
			JFormattedComboBox cb = (JFormattedComboBox)evt.getSource();
			String text = totalAmt.getText()+" will be deducted from bank account "
							+ cb.getSelectedItemFormattedValue() + ". Thank you.";			
			L8.setText(text);
		}
	});


}
/**
 * Convert a Long(999999) to a string "9999.99"
 */
public String longToDecimalString(Long l) 
{
	String stemp1 = l.toString();
	String stemp2;
	if (stemp1.length() >= 3)
		stemp2 = stemp1.substring(0, stemp1.length()-2)+'.'+stemp1.substring(stemp1.length()-2);
	else
		stemp2 = stemp1;
	return stemp2;
}
public static void main(String s[]) 
{
	JFormattedBeans p= new JFormattedBeans();
	p.addWindowListener (new WindowAdapter ()
	{
   	 public void windowClosing (WindowEvent event)
	    {
	        System.exit (0);
	    }
	});
	p.pack();
	p.setVisible(true);
}
/**
 * Minus sign at the end is moved to the front. Any plus sign is removed.
 * @return java.lang.String
 * @param str java.lang.String
 */
public String moveSign(String str) 
{
	String finalStr = "";
	
	if (str.indexOf('-') > 0)
	{
		finalStr = '-' + str.substring(0, str.length()-1);
	}
	else if (str.indexOf('+') > 0)
	{
		finalStr = str.substring(0, str.length()-1);
	}
	else if (str.indexOf('+') == 0)
	{
		finalStr = str.substring(1);
	}
	else 
		finalStr = str;
		
	return finalStr;
}
/**
 * set up the priceColumn
 * 
 */
private void setUpAmountColumn(JFormattedTableColumn aAmtColumn)
{
	// do nothing if the column is null 
	if (aAmtColumn == null )
	    return;
	else 
	{ 
		// set up the field model
		Attributes dataAttr3 = new DataAttributes(DataAttributes.DATATYPE_NUMERIC,10, 2, '.');
		Formatter formatter3 = new EditcodeEditwordFormatter(dataAttr3, '1', EditcodeEditwordFormatter.EDITCODEPARM_CURRENCY, null);
		FieldModel fm3= new AS400FieldModel(dataAttr3, formatter3);
		aAmtColumn.setFieldModel(fm3);


		JFormattedLabelCellRenderer aCellRenderer = (JFormattedLabelCellRenderer)aAmtColumn.getCellRenderer();
		aCellRenderer.setHorizontalAlignment(javax.swing.JLabel.RIGHT);


		// set amount column as non-editable
		aAmtColumn.setCellEditable(false);
	}	
	
	
		
}
/*
 * Set up the Shipping Date column in the JFormattedTable, such that
 * it's cell is a JFormattedComboBoxCellEditor.
 */
public void setUpDateColumn(JFormattedTableColumn dateColumn) 
{
	// do nothing if the column is null 
	if (dateColumn == null )
	    return;
	else 
	{  
		// set up the field model
		Attributes dataAttr2 = new DataAttributes(DataAttributes.DATATYPE_NUMERIC, 8);
		Formatter formatter2 = new EditcodeEditwordFormatter(dataAttr2, 'Y', EditcodeEditwordFormatter.EDITCODEPARM_NONE, null);
		AS400FieldModel	fm2	= new AS400FieldModel(dataAttr2, formatter2);
		
		dateColumn.setFieldModel(fm2);
	
		// set up the cell editor as a customized JFormattedComboBoxCellEditor
		JFormattedComboBoxCellEditor aCellEditor = new JFormattedComboBoxCellEditor(dates);
		dateColumn.setCellEditor(aCellEditor);


		// set up the cell renderer's ToolTipText
		JFormattedLabelCellRenderer aCellRenderer = (JFormattedLabelCellRenderer)dateColumn.getCellRenderer();
		aCellRenderer.setToolTipText("Select a shipping date from the combo box list");


	}


}
/*
 * Set up the Item column in the JFormattedTable, such that it's cell is a 
 * JFormattedComboBoxCellEditor. 
 */
public void setUpItemColumn(JFormattedTableColumn itemColumn) 
{
	// do nothing if the column is null 
	if (itemColumn == null )
	    return;
	else 
	{  
	//Set up the editor for the item cells.The editor is a JFormattedComboBoxCellEditor.
	JFormattedComboBoxCellEditor itemComboEditor = new JFormattedComboBoxCellEditor(items);
	itemColumn.setCellEditor(itemComboEditor);


	//Set up tool tip for the item column header.
	TableCellRenderer headerRenderer = itemColumn.getHeaderRenderer();
	if (headerRenderer instanceof DefaultTableCellRenderer) 
	{
		((DefaultTableCellRenderer)headerRenderer).setToolTipText(
				 "Select an item from the combo box list");
	}
	
	itemComboEditor.addItemListener(new ItemListener() 
	{
		public void itemStateChanged(ItemEvent evt) 
		{
			JFormattedComboBox cb = (JFormattedComboBox)evt.getSource();


			// the row that is currently editing in the table
			int row = itemTable.getEditingRow();
			if (row >=0)
			{
				int i = cb.getSelectedIndex();


				itemModel.setValueAt(prices[i],row,2);
				Long  lpr  = stringToLongValue(prices[i]);
				Long  lqty = new Long(itemModel.getValueAt(row,3).toString());
				Long  lamt = new Long(lpr.longValue() * lqty.longValue());
				String samt=longToDecimalString(lamt);
				itemModel.setValueAt(samt,row,4);


			}


			itemTable.repaint();
			updateTotalAmount();
		}
	});
	}
}
/**
 * set up the price column
 * 
 */
private void setUpPriceColumn(JFormattedTableColumn aPriceColumn)
{
	// do nothing if the column is null 
	if (aPriceColumn == null )
	   return;
	else 
	{  
		// set up the field model
		Attributes dataAttr3 = new DataAttributes(DataAttributes.DATATYPE_NUMERIC,10, 2, '.');
		Formatter formatter3 = new EditcodeEditwordFormatter(dataAttr3, '1', EditcodeEditwordFormatter.EDITCODEPARM_CURRENCY, null);
		FieldModel fm3= new AS400FieldModel(dataAttr3, formatter3);
		aPriceColumn.setFieldModel(fm3);


		JFormattedLabelCellRenderer aCellRenderer = (JFormattedLabelCellRenderer)aPriceColumn.getCellRenderer();
		aCellRenderer.setHorizontalAlignment(javax.swing.JLabel.RIGHT);


		// set price column as non-editable
		aPriceColumn.setCellEditable(false);
	}	
		
}
/*
 * Set up the Quantity column in the JFormattedTable.
 * The cell renderer is a JFormattedLabelRenderer
 * with the same field model as the JFormattedTextFieldCellEditor.
 */
public void setUpQuantityColumn(JFormattedTableColumn qtyColumn) 
{
	// do nothing if the column is null 
	if (qtyColumn == null )
		return;
	else 
	{  
		// set up the field model
		Attributes dataAttr = new DataAttributes(DataAttributes.DATATYPE_NUMERIC, 4);
		Formatter formatter = new EditcodeEditwordFormatter(dataAttr, '1', EditcodeEditwordFormatter.EDITCODEPARM_NONE, null);
		Validator val       = new ComparisonRangeValidator(dataAttr, 
									ComparisonRangeValidator.VALIDITYTYPE_COMPARISON,
									ComparisonRangeValidator.COMPARISON_GE,
									"0", null, null);
		AS400FieldModel	fm1	= new AS400FieldModel(dataAttr, formatter, null/*val*/, null);
		qtyColumn.setFieldModel(fm1);
	
		// set up the cellrenderer as a customized JFormattedLabelCellRenderer: align to RIGHT when renderring
		JFormattedLabelCellRenderer aCellRenderer = (JFormattedLabelCellRenderer)qtyColumn.getCellRenderer();
		aCellRenderer.setHorizontalAlignment(javax.swing.JLabel.RIGHT);
	
		// set up the celleditor as a customized JFormattedTextFieldCellEditor: align to RIGHT when editing
		JFormattedTextFieldCellEditor aCellEditor = (JFormattedTextFieldCellEditor)qtyColumn.getCellEditor();
		aCellEditor.setHorizontalAlignment(javax.swing.JTextField.RIGHT);


		aCellEditor.addFocusListener(new FocusListener() 
		{
			public void focusGained(java.awt.event.FocusEvent e){};
			public void focusLost(java.awt.event.FocusEvent e) 
			{
				// Update Amount field
				JFormattedTextFieldCellEditor tf = (JFormattedTextFieldCellEditor)e.getSource();
				int row = itemTable.getEditingRow();
				Long lp = stringToLongValue(itemModel.getValueAt(row,2).toString());
				Long lq = stringToLongValue(tf.getUnformattedText());
				Long lamt = new Long(lp.longValue() * lq.longValue() / 100L);
				String samt = longToDecimalString(lamt);
				itemModel.setValueAt(samt,row,4);
				itemTable.repaint();
				updateTotalAmount();


			};
		});
	
	}


}
/**
 * Convert a numeric string "9999.99" to a Long(999999)
 */
public Long stringToLongValue(String s) 
{
	String tempStr = moveSign(s);
	Double d = new Double(tempStr);
	Long  l = new Long((long)(d.doubleValue() * 100));
	return l;
}
/**
 * Update Total amount
 */
public void updateTotalAmount() 
{
	Long total = new Long(0);
	String s = "";
	
	for (int row=0; row<data.length; row++)
	{
		// Accumulate the total amount
		// Have to use long, because when double is a large number,
		// it is in exponential form.
		Long ltemp = stringToLongValue(itemModel.getValueAt(row,4).toString()/*(String)unformattedData[row][4]*/);
		total = new Long(total.longValue() + ltemp.longValue());
	}
	try
	{
		s = longToDecimalString(total);
		totalAmt.setUnformattedText(s);
		String text = totalAmt.getText()+" will be deducted from bank account "
							+ bankAcc.getSelectedItemFormattedValue() + ". Thank you.";			
		L8.setText(text);
	}
	catch (Exception e3)
	{
		System.out.println("Invalid Total Amount: "+s);
	}


}
}
