package com.ibm.etools.iseries.examples.jformatted.JFormattedTextFieldSample;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 2002 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if IBM has been
// advised of the possibility of such damages.


/**
 * This sample program demonstrates the use of JFormattedTextField.
 * It shows the differences of different set and get methods of 
 * JFormattedTextField.
 *
 * Functions that you can perform with the example:
 * 1) You can type in a value in the text field, or click on any set buttons
 * which will set the the field with a predefined value. Then click on
 * any get buttons to see  different values return in the label field.
 * You can use clear button to clear the text field or the label field.
 * The difference between unformatted value and internal value is internal
 * value does not have decimal point.
 */


import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.ibm.etools.iseries.ui.AS400FieldModel;
import com.ibm.etools.iseries.ui.ComparisonRangeValidator;
import com.ibm.etools.iseries.ui.DataAttributes;
import com.ibm.etools.iseries.ui.EditcodeEditwordFormatter;
import com.ibm.etools.iseries.ui.EditmaskAttributes;
import com.ibm.etools.iseries.ui.JFormattedTextField;




public class JFormattedTextFieldSample extends javax.swing.JFrame 
	implements java.awt.event.ActionListener
{
	private JButton bSetText1;
	private JButton bGetText1;
	private JButton bSetUnformattedText1;
	private JButton bGetUnformattedText1;
	private JButton bSetInternalValue1;
	private JButton bGetInternalValue1;
	
	private JButton bSetText2;				
	private JButton bGetText2;
	private JButton bSetUnformattedText2;
	private JButton bGetUnformattedText2;
	private JButton bSetInternalValue2;
	private JButton bGetInternalValue2;
	
	private JButton bSetText3;				
	private	JButton bSetUnformattedText3;
	private JButton bSetInternalValue3;
	
	private JButton bSetText4;
	private JButton bGetText4;
	private JButton bSetUnformattedText4;
	private JButton bGetUnformattedText4;
	private JButton bSetInternalValue4;
	private JButton bGetInternalValue4;
	
	private JButton bClear1;
	private JButton bClear2;
	private JButton bClear3;
	private JButton bClear4;
	private JButton bClear5;
	private JButton bClear6;
	
	private JFormattedTextField setfield1;
	private JFormattedTextField setfield2;
	private JFormattedTextField setfield3;
	
	private JLabel getfield1;
	private JLabel getfield2;
	private JLabel getfield3;
	




/**
 * Constructor
 */
public JFormattedTextFieldSample() 
{
	super("JFormattedTextFieldSample");
	setSize(822, 488);
	setContentPane(getJFrameContentPane());
	
}




/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
private javax.swing.JPanel getJFrameContentPane() 
{
	JPanel contentPane = new JPanel();
	contentPane.setLayout(null);
	
	// ----------------------------------------------------------
	// JFormattedTextField sample 1 
	// (Data type is Numeric, length 10, decimalPlaces 2, 
	// autoAdvance, editcode "A", editcodeParmType "asterisk"
	// ----------------------------------------------------------
	JLabel label2 = new JLabel("JFormattedTextField (Numeric, length 10, decimalPlaces 2, autoAdvance, editcode \'A\', editcodeParmType \'asterisk\'):");
	label2.setBounds(8, 50, 801, 17);
	contentPane.add(label2);


	bSetText1 = new JButton("SetText");
	bSetText1.setBounds(9, 70, 153, 25);
	contentPane.add(bSetText1);


	bSetUnformattedText1 = new JButton("SetUnformattedText");
	bSetUnformattedText1.setBounds(169, 70, 153, 25);
	contentPane.add(bSetUnformattedText1);


	bSetInternalValue1 = new JButton("SetInternalValue");
	bSetInternalValue1.setBounds(329, 70, 153, 25);
	contentPane.add(bSetInternalValue1);
	
	// Create a JFormattedTextField 
	// DataAttributes is set to numeric data type, with length of 10, decimal places of 2
	// EditcodeEditwordFormatter is set to edit code 'A' and parameter type asterisk
	try
	{
		DataAttributes attributes1 = new com.ibm.etools.iseries.ui.DataAttributes(DataAttributes.DATATYPE_NUMERIC, 10, 2, '.');
		EditcodeEditwordFormatter formatter1 = new com.ibm.etools.iseries.ui.EditcodeEditwordFormatter(); 
		formatter1.setEditCode('A');
		formatter1.setEditCodeParmType(EditcodeEditwordFormatter.EDITCODEPARM_ASTERISK);
		AS400FieldModel fldModel1 = new com.ibm.etools.iseries.ui.AS400FieldModel(attributes1, formatter1);
		setfield1 = new com.ibm.etools.iseries.ui.JFormattedTextField(fldModel1);
		setfield1.setBounds(488, 70, 201, 25);
		contentPane.add(setfield1);
	}
	catch (Exception e1)
	{
		e1.printStackTrace();
	}
	
	bClear1 = new JButton("Clear");
	bClear1.setBounds(697, 71, 108, 24);
	contentPane.add(bClear1);
	
	bGetText1 = new JButton("GetText");
	bGetText1.setBounds(9, 99, 153, 25);
	contentPane.add(bGetText1);


	bGetUnformattedText1 = new JButton("GetUnformattedText");
	bGetUnformattedText1.setBounds(169, 99, 153, 25);
	contentPane.add(bGetUnformattedText1);
		
	bGetInternalValue1 = new JButton("GetInternalValue");
	bGetInternalValue1.setBounds(329, 99, 153, 25);
	contentPane.add(bGetInternalValue1);
	
	getfield1 = new JLabel();
	getfield1.setBorder(new javax.swing.border.EtchedBorder());
	getfield1.setBackground(java.awt.Color.gray);
	getfield1.setBounds(488, 99, 201, 25);
	contentPane.add(getfield1);
	
	bClear2 = new JButton("Clear");
	bClear2.setBounds(697, 100, 108, 24);
	contentPane.add(bClear2);
	
	
	// ----------------------------------------------------------
	// JFormattedTextField sample 2
	// (Data type is numeric, length 10, decimal places 0, 
	// autoAdvance, editword "(   )   -    ", editmask "&   &   &    "
	// Comparison >= "8000000000", reverseImage=magenta, Background=Yellow)
	// ----------------------------------------------------------
	JLabel label3 = new JLabel("JFormattedTextField (Numeric, length 10, decimal places 0, autoAdvance, editword   \"(   )   -    \", editmask \"&   &   &    \",");
	label3.setBounds(12, 152, 788, 16);
	contentPane.add(label3);
	
	JLabel label4 = new JLabel(" Comparison >= \"8000000000\", reverseImage=magenta, Background=Yellow):");
	label4.setBounds(10, 168, 794, 14);
	contentPane.add(label4);
	
	bSetText2 = new JButton("SetText");
	bSetText2.setBounds(9, 190, 153, 25);
	contentPane.add(bSetText2);
	
	bSetUnformattedText2 = new JButton("SetUnformattedText");
	bSetUnformattedText2.setBounds(169, 190, 153, 25);
	contentPane.add(bSetUnformattedText2);
			
	bSetInternalValue2 = new JButton("SetInternalValue");
	bSetInternalValue2.setBounds(329, 190, 153, 25);
	contentPane.add(bSetInternalValue2);
			
	// Create a JFormattedTextField with editmask.
	// DataAttributes is set to numeric data type, with length of 10, decimal places of 0,
	// when error occurs, the background is turn to magenta.
	try
	{
		DataAttributes attributes2 = new DataAttributes(true, DataAttributes.DATATYPE_NUMERIC, 10, 0, '.', java.awt.Color.magenta, true);
		EditmaskAttributes editmask = new EditmaskAttributes("(   )   -    ", "&   &   &    ");
		AS400FieldModel fldModel2 = new AS400FieldModel(attributes2);
		ComparisonRangeValidator validator2= new com.ibm.etools.iseries.ui.ComparisonRangeValidator();
		validator2.setValidityCheckType(ComparisonRangeValidator.VALIDITYTYPE_COMPARISON);
		validator2.setComparisonValue("8000000000");
		validator2.setComparisonType(ComparisonRangeValidator.COMPARISON_GE);
		fldModel2.setValidator(validator2);
		setfield2 = new JFormattedTextField(fldModel2);
		setfield2.setEditmaskAttributes(editmask);
		setfield2.setBackground(java.awt.Color.yellow);
		setfield2.setBounds(488, 190, 201, 25);
		contentPane.add(setfield2);
	}
	catch (Exception e1)
	{
		e1.printStackTrace();
	}


	bClear3 = new JButton("Clear");
	bClear3.setBounds(697, 191, 108, 24);
	contentPane.add(bClear3);
	
	bGetText2 = new JButton("GetText");
	bGetText2.setBounds(9, 219, 153, 25);
	contentPane.add(bGetText2);
			
	bGetUnformattedText2 = new JButton("GetUnformattedText");
	bGetUnformattedText2.setBounds(169, 219, 153, 25);
	contentPane.add(bGetUnformattedText2);
			
	bGetInternalValue2 = new JButton("GetInternalValue");
	bGetInternalValue2.setBounds(329, 219, 153, 25);
	contentPane.add(bGetInternalValue2);
	
	getfield2 = new JLabel();
	getfield2.setBorder(new javax.swing.border.EtchedBorder());
	getfield2.setBackground(java.awt.Color.gray);
	getfield2.setBounds(488, 219, 201, 25);
	contentPane.add(getfield2);
			
	bClear4 = new JButton("Clear");
	bClear4.setBounds(697, 220, 108, 24);
	contentPane.add(bClear4);
	


	
	// ----------------------------------------------------------
	// JFormattedTextField sample 3
	// Data type is character, length 9, editword "  /   -  -  \",
	// Range validity 'AA0000000' to 'ZZ9999999', 
	// KeystrokeVerifier is UpperCaseDocument.
	// ----------------------------------------------------------
	JLabel label5 = new JLabel("JFormattedTextField (Character, length 9, editword \"  /   -  -  \", Range validity \'AA0000000\' to \'ZZ9999999\', UpperCaseDocument): ");
	label5.setBounds(11, 275, 795, 14);
	contentPane.add(label5);
				
	JLabel label6 = new javax.swing.JLabel("The field is initialized to \'AB1112222\'.");
	label6.setBounds(10, 290, 798, 17);
	contentPane.add(label6);
			
	JLabel label7 = new javax.swing.JLabel("Set with valid data:");
	label7.setBounds(11, 312, 166, 16);
	label7.setForeground(java.awt.Color.blue);
	contentPane.add(label7);
			
	JLabel label8 = new javax.swing.JLabel("Set with invalid data (Press the Clear button to clear the status):");
	label8.setBounds(12, 362, 419, 17);
	label8.setForeground(java.awt.Color.blue);
	contentPane.add(label8);
	
	bSetText3 = new JButton("SetText");
	bSetText3.setBounds(9, 330, 153, 25);
	contentPane.add(bSetText3);
	
	bSetUnformattedText3 = new JButton("SetUnformattedText");
	bSetUnformattedText3.setBounds(169, 330, 153, 25);
	contentPane.add(bSetUnformattedText3);
			
	bSetInternalValue3 = new JButton("SetInternalValue");
	bSetInternalValue3.setBounds(329, 330, 153, 25);
	contentPane.add(bSetInternalValue3);
			
	// Create a JFormattedTextField with edit word.
	// DataAttributes is set to character data type, with length of 9.
	// AS400FieldModel is set with a KeystrokeVerifier, which convert
	// all the keys entered to uppercase characters.
	try
	{
		DataAttributes attributes3 = new DataAttributes(DataAttributes.DATATYPE_CHARACTER, 9);
		EditcodeEditwordFormatter formatter3 = new EditcodeEditwordFormatter();
		formatter3.setEditWord("  /  -  -   ");
		ComparisonRangeValidator validator3 = new com.ibm.etools.iseries.ui.ComparisonRangeValidator();
		validator3.setValidityCheckType(ComparisonRangeValidator.VALIDITYTYPE_RANGE);
		validator3.setMaximumRange("ZZ9999999");
		validator3.setMinimumRange("AA0000000");
		AS400FieldModel fldModel3 = new AS400FieldModel(attributes3, formatter3);
		fldModel3.setKeystrokeVerifier(new com.ibm.etools.iseries.ui.UpperCaseDocument());
		fldModel3.setValidator(validator3);
		setfield3 = new JFormattedTextField(fldModel3);
		setfield3.setBounds(488, 330, 201, 25);
		contentPane.add(setfield3);
	}
	catch (Exception e1)
	{
		e1.printStackTrace();
	}
	
	bClear5 = new JButton("Clear");
	bClear5.setBounds(697, 331, 108, 24);
	contentPane.add(bClear5);
	
	bSetText4 = new JButton("SetText");
	bSetText4.setBounds(9, 380, 153, 25);	
	contentPane.add(bSetText4);
	
	bSetUnformattedText4 = new JButton("SetUnformattedText");
	bSetUnformattedText4.setBounds(169, 381, 153, 25);
	contentPane.add(bSetUnformattedText4);


	bSetInternalValue4 = new JButton("SetInternalValue");
	bSetInternalValue4.setBounds(329, 381, 153, 25);
	contentPane.add(bSetInternalValue4);
			
	bClear6 = new JButton("Clear");
	bClear6.setBounds(697, 382, 108, 24);
	contentPane.add(bClear6);
	
	bGetText4 = new JButton("GetText");
	bGetText4.setBounds(9, 411, 153, 25);
	contentPane.add(bGetText4);
			
	bGetUnformattedText4 = new JButton("GetUnformattedText");
	bGetUnformattedText4.setBounds(169, 411, 153, 25);
	contentPane.add(bGetUnformattedText4);
			
	bGetInternalValue4 = new JButton("GetInternalValue");
	bGetInternalValue4.setBounds(329, 411, 153, 25);
	contentPane.add(bGetInternalValue4);
	
	getfield3 = new JLabel();
	getfield3.setBorder(new javax.swing.border.EtchedBorder());
	getfield3.setBackground(java.awt.Color.gray);
	getfield3.setBounds(489, 411, 315, 25);
	contentPane.add(getfield3);






	// Add listeners to all buttons
	bSetText1.addActionListener(this);
	bGetText1.addActionListener(this);
	bSetUnformattedText1.addActionListener(this);
	bGetUnformattedText1.addActionListener(this);
	bSetInternalValue1.addActionListener(this);
	bGetInternalValue1.addActionListener(this);
	bSetText2.addActionListener(this);				
	bGetText2.addActionListener(this);
	bSetUnformattedText2.addActionListener(this);
	bGetUnformattedText2.addActionListener(this);
	bSetInternalValue2.addActionListener(this);
	bGetInternalValue2.addActionListener(this);
	bSetText3.addActionListener(this);				
	bSetUnformattedText3.addActionListener(this);
	bSetInternalValue3.addActionListener(this);
	bSetText4.addActionListener(this);
	bGetText4.addActionListener(this);
	bSetUnformattedText4.addActionListener(this);
	bGetUnformattedText4.addActionListener(this);
	bSetInternalValue4.addActionListener(this);
	bGetInternalValue4.addActionListener(this);
	bClear1.addActionListener(this);
	bClear2.addActionListener(this);
	bClear3.addActionListener(this);
	bClear4.addActionListener(this);
	bClear5.addActionListener(this);
	bClear6.addActionListener(this);
	
	return contentPane;
}


/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		JFormattedTextFieldSample aJFormattedTextFieldSample;
		aJFormattedTextFieldSample = new JFormattedTextFieldSample();
		aJFormattedTextFieldSample.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		aJFormattedTextFieldSample.show();
		aJFormattedTextFieldSample.setVisible(true);
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main()");
		exception.printStackTrace(System.out);
	}
}


public void actionPerformed(java.awt.event.ActionEvent e) 
{
	Object obj = e.getSource();
	
	try
	{
		if (obj == bSetText1) 
			setfield1.setText("5566778.99-");
		else if (obj == bSetUnformattedText1) 
			setfield1.setUnformattedText("5566778.99-");
		else if (obj == bSetInternalValue1) 
			setfield1.setInternalValue("556677899-");
		else if (obj == bClear1) 
			setfield1.setText(new java.lang.String());
		else if (obj == bGetText1) 
			getfield1.setText(setfield1.getText());
		else if (obj == bGetUnformattedText1) 
			getfield1.setText(setfield1.getUnformattedText());
		else if (obj == bGetInternalValue1) 
			getfield1.setText(setfield1.getInternalValue());
		else if (obj == bClear2) 
			getfield1.setText(new java.lang.String());
		
		else if (obj == bSetText2) 
			setfield2.setText("8882223333");
		else if (obj == bSetUnformattedText2) 
			setfield2.setUnformattedText("8882223333");
		else if (obj == bSetInternalValue2) 
			setfield2.setInternalValue("8882223333");
		else if (obj == bClear3) 
			setfield2.setText(new java.lang.String());	
		else if (obj == bGetText2) 
			getfield2.setText(setfield2.getText());
		else if (obj == bGetUnformattedText2) 
			getfield2.setText(setfield2.getUnformattedText());
		else if (obj == bGetInternalValue2) 
			getfield2.setText(setfield2.getInternalValue());
		else if (obj == bClear4) 
			getfield2.setText(new java.lang.String());
		
		else if (obj == bSetText3) 
			setfield3.setText("ZJ8762200");
		else if (obj == bSetUnformattedText3) 
			setfield3.setUnformattedText("ZJ8762200");
		else if (obj == bSetInternalValue3) 
			setfield3.setInternalValue("ZJ8762200");
		else if (obj == bClear5) 
			setfield3.setText(new java.lang.String());
		else if (obj == bSetText4) 
			try
			{
				setfield3.setText("1234567890");
			}
			catch (Exception ex1)
			{
					getfield3.setText(String.valueOf(ex1));
			}
		else if (obj == bSetUnformattedText4) 
			try
			{
				setfield3.setUnformattedText("1234567890");
			}
			catch (Exception ex2)
			{
					getfield3.setText(String.valueOf(ex2));
			}
		else if (obj == bSetInternalValue4) 
			try
			{
				setfield3.setInternalValue("1234567890");
			}
			catch (Exception ex3)
			{
					getfield3.setText(String.valueOf(ex3));
			}
		else if (obj == bClear6) 
			getfield3.setText(new java.lang.String());
		else if (obj == bGetText4) 
			getfield3.setText(setfield3.getText());
		else if (obj == bGetUnformattedText4) 
			getfield3.setText(setfield3.getUnformattedText());
		else if (obj == bGetInternalValue4) 
			getfield3.setText(setfield3.getInternalValue());
	}
	catch (Exception ex)
	{
		ex.printStackTrace();
	}
}




}
