//Licensed Material - Property of IBM
//(C) Copyright IBM Corp. 2004 - All Rights Reserved
//
//DISCLAIMER:
//The following [enclosed] code is sample code created by IBM
//Corporation.  This sample code is not part of any standard IBM product
//and is provided to you solely for the purpose of assisting you in the
//development of your applications.  The code is provided 'AS IS',
//without warranty of any kind.  IBM shall not be liable for any damages
//arising out of your use of the sample code, even if they have been
//advised of the possibility of such damages.

//This class extends JFrame.  It was built using the JVE.  Demostrates
//use of Toolbox to call a program, and use AS400 object to gather
//OS release information.

package com.ibm.etools.iseries.examples.toolbox.ve;

import javax.swing.JFrame;

import javax.swing.JPanel;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyVetoException;
import java.io.IOException;

import javax.swing.JTextField;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import com.ibm.as400.access.AS400;
import com.ibm.as400.access.AS400SecurityException;
import com.ibm.as400.data.PcmlException;
import com.ibm.as400.data.ProgramCallDocument;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;


public class ToolboxJVESample extends JFrame {

	private javax.swing.JPanel jContentPane = null;

	private JPanel jPanel = null;
	private JLabel jLabel = null;
	private JTextField jTextField = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JTextField jTextField1 = null;
	private JTextField jTextField2 = null;
	private JPanel jPanel1 = null;
	private JButton jButton = null;
	private AS400 aS400 = null;  //  @jve:decl-index=0:visual-constraint="476,44"
	private ProgramCallDocument programCallDocument = null;  //  @jve:decl-index=0:visual-constraint="439,91"
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			jLabel2 = new JLabel();
			jLabel1 = new JLabel();
			jLabel = new JLabel();
			java.awt.GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			java.awt.GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
			jLabel.setText("System Name:");
			jLabel.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
			jLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 2;
			gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
			jLabel1.setText("System Time:");
			jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 3;
			gridBagConstraints5.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
			jLabel2.setText("System OS Level:");
			jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridy = 2;
			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints7.gridx = 1;
			gridBagConstraints7.gridy = 3;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints8.gridx = 0;
			gridBagConstraints8.gridy = 4;
			jPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 5;
			gridBagConstraints1.gridwidth = 2;
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.gridy = 0;
			gridBagConstraints31.weightx = 1.0;
			gridBagConstraints31.weighty = 1.0;
			gridBagConstraints31.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints31.gridwidth = 2;
			jPanel.add(jLabel, gridBagConstraints2);
			jPanel.add(getJTextField(), gridBagConstraints3);
			jPanel.add(jLabel1, gridBagConstraints4);
			jPanel.add(jLabel2, gridBagConstraints5);
			jPanel.add(getJTextField1(), gridBagConstraints6);
			jPanel.add(getJTextField2(), gridBagConstraints7);
			jPanel.add(getJPanel1(), gridBagConstraints8);
			jPanel.add(getJButton(), gridBagConstraints1);
			jPanel.add(getJScrollPane(), gridBagConstraints31);
		}
		return jPanel;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setText("MyiSeries");
			jTextField.setToolTipText("Please enter system name");
			jTextField.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return jTextField;
	}
	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setEditable(false);
			jTextField1.setEnabled(false);
		}
		return jTextField1;
	}
	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setEditable(false);
			jTextField2.setEnabled(false);
		}
		return jTextField2;
	}
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BoxLayout(jPanel1, BoxLayout.Y_AXIS));
		}
		return jPanel1;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Connect, and update");
			jButton.setToolTipText("Click to have values refreshed");
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					aS400=null;
					try {
						if (getAS400().getSystemName().length()==0)
							getAS400().setSystemName(getJTextField().getText());
					} catch (PropertyVetoException e4) {
						// TODO Auto-generated catch block
						e4.printStackTrace();
					}
					try {
						getAS400().connectService(AS400.COMMAND);
					} catch (AS400SecurityException e3) {
						// TODO Auto-generated catch block
						e3.printStackTrace();
					} catch (IOException e3) {
						// TODO Auto-generated catch block
						e3.printStackTrace();
					}
					try {
						getJTextField2().setText(Integer.toHexString(getAS400().getVRM()));
					} catch (AS400SecurityException e1) {
						// TODO Auto-generated catch block
						getJTextField2().setText("Exception: "+e1);
						e1.printStackTrace();
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						getJTextField2().setText("Exception: "+e1);
						e1.printStackTrace();
					}
					try {
						ProgramCallDocument pcml = getProgramCallDocument();
						boolean rc = pcml.callProgram("time");
						jTextField1.setText((String) (rc == false?"-- call failed --":pcml.getValue("time" + ".time")));
					} catch (PcmlException e2) {
						System.out.println(e2.getLocalizedMessage());
						jTextField1.setText("Exception: "+e2);
						e2.printStackTrace();
						System.out.println("*** Call to "+"time"+" failed. ***");
					} catch (Exception e2){
						System.out.println(e2.getLocalizedMessage());
						jTextField1.setText("Exception: "+e2);
						e2.printStackTrace();
					}
			}
		});
		}
		return jButton;
	}
	/**
	 * This method initializes aS400	
	 * 	
	 * @return com.ibm.as400.access.AS400	
	 */    
	private AS400 getAS400() {
		if (aS400 == null) {
			aS400 = new AS400();
		}
		return aS400;
	}
	/**
	 * This method initializes programCallDocument	
	 * 	
	 * @return com.ibm.as400.data.ProgramCallDocument	
	 */    
	private ProgramCallDocument getProgramCallDocument() {
		if (programCallDocument == null) {
			try {
				programCallDocument = new ProgramCallDocument();
				programCallDocument.setDocument("com.ibm.etools.iseries.examples.toolbox.ve.time.pcml");
			} catch (PcmlException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		programCallDocument.setSystem(getAS400());
		return programCallDocument;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
			jScrollPane.setEnabled(false);
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */    
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setEditable(false);
			jTextArea.setEnabled(false);
			jTextArea.setText(
				"This sample was built using the Java Visual Editor.\n\n" +
				"It makes use of the Toolbox to call an iSeries program to retrieve\n" +
				"the system time, and a Toolbox API to retrieve the OS level.");
		}
		return jTextArea;
	}
      public static void main(String[] args) {
        		ToolboxJVESample f=new ToolboxJVESample();
        		f.addWindowListener(new WindowAdapter() {
        			public void windowClosing(WindowEvent e) {
        				System.exit(0);
        			};
        		});
        		f.setVisible(true);
	}
	/**
	 * This is the default constructor
	 */
	public ToolboxJVESample() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(371, 203);
		this.setContentPane(getJContentPane());
		this.setTitle("Toolbox Example created in JVE");
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJPanel(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
