package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


// This class extends JPanel.  It illustrates the use of toolbox visual IFS classes.


import java.awt.Component;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.ibm.as400.access.AS400;
import com.ibm.as400.vaccess.AS400ExplorerPane;
import com.ibm.as400.vaccess.ErrorDialogAdapter;
import com.ibm.as400.vaccess.FileFilter;
import com.ibm.as400.vaccess.IFSFileDialog;
import com.ibm.as400.vaccess.IFSTextFileDocument;
import com.ibm.as400.vaccess.VIFSDirectory;
import com.ibm.as400.vaccess.WorkingCursorAdapter;


public class IFSExample extends JPanel implements ActionListener{


private ToolboxDemo	parentFrame;


private JLabel		l1,l2;
private JTextField	t2;
private JTextField	t3=new JTextField(11);


private VIFSDirectory 		root=new VIFSDirectory();
private AS400ExplorerPane 	pane=new AS400ExplorerPane();
private IFSTextFileDocument	document = new IFSTextFileDocument ();
private JTextArea			fileStuff=new JTextArea();
private JScrollPane			scrollpane=new JScrollPane();


private JButton		populatePB=new JButton("Get IFS tree");
private JButton		fileDialogPB=new JButton("File Dialog");
private JButton		callPB=new JButton("Call Java Program");


public AS400		as400Connection;








































































public IFSExample(ToolboxDemo t) {
	parentFrame=t;
	// Set up labels
	t2=new JTextField(parentFrame.AS400Name,9);
	l1=new JLabel("This panel demonstrates use of AS/400 Toolbox IFS Visual classes.");
	l2=new JLabel("AS400:");
	// Add listeners
	populatePB.addActionListener(this);
	callPB.addActionListener(this);
	fileDialogPB.addActionListener(this);
	
	t3.setEnabled(false);
	callPB.setEnabled(false);
	scrollpane.setPreferredSize(new Dimension(800, 230));
	scrollpane.setMinimumSize(new Dimension(500, 150));
	scrollpane.getViewport().add(fileStuff);
	pane.setPreferredSize(new Dimension(800,230));
	pane.setMinimumSize(new Dimension(500,150));


	// Add tooltip text:
	callPB.setToolTipText("Press to start JAVA Console");
	fileDialogPB.setToolTipText("Press to display IFS File Dialog");
	fileStuff.setToolTipText("Displays contents of file selected via file dialog");
	populatePB.setToolTipText("Press to have pane populated with IFS tree");


	// Add items to panel
	setLayout(new GridBagLayout());
	addit1(l1,0,0,6,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l2,1,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(t2,2,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(t3,1,2,6,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(callPB,7,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(fileDialogPB,7,2,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(scrollpane,1,3,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(new JLabel("AS/400 Explorer panel:"),1,6,4,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.SOUTHWEST,
		1,10,1,1,1,1);
	addit1(populatePB,7,6,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,10,1,1,1,1);
	addit1(pane,1,7,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
  }
public void actionPerformed(ActionEvent e) {
	try {
		if(e.getSource() == callPB) {
			// User wishes to execute selected class.  Bring up JavaPanel in
			// its own JFrame.
			JavaExecutionPanel jP=new JavaExecutionPanel(as400Connection,
					                 					t3.getText());
			jP.setVisible(true);
		}
		if(e.getSource() == populatePB) {
			// Retrieve IFS tree and update AS400ExplorerPane with it.
	 		parentFrame.status.setText("Connecting ....");
			as400Connection=new AS400(t2.getText());
			as400Connection.connectService(AS400.FILE);
	 		parentFrame.status.setText("Retrieving IFS directory tree ....");
			root = new VIFSDirectory (as400Connection, "/"); 
	 		parentFrame.status.setText("Loading AS400ExplorerPane with directory tree ....");
			pane.setRoot(root);
			pane.load ();		
	 		parentFrame.status.setText("Idle.");
		}
		if(e.getSource() == fileDialogPB) {
			// Present user with IFSFileDialog:
	 		parentFrame.status.setText("Connecting ....");
			as400Connection=new AS400(t2.getText());
			as400Connection.connectService(AS400.FILE);
	 		parentFrame.status.setText("Starting IFSDialog ....");
			IFSFileDialog dialog = new IFSFileDialog (	(Frame)parentFrame,
										t2.getText().trim() +" - IFS File System",
										as400Connection);
			// Set a list of filters for the dialog, then set the
			// filters in the dialog.  The first filter will be used
			// when the dialog is first displayed.
	 		FileFilter[] filterList = {	new FileFilter ("All files (*.*)","*.*"),
										new FileFilter ("HTML files (*.HTML", "*.HTM")};
			dialog.setFileFilter (filterList, 0);
			// Set the text on the buttons.
	 		dialog.setOkButtonText ("Open");
			dialog.setCancelButtonText ("Cancel");
	 		// Show the dialog.  If the user selected a file by
			// pressing the Open button, then display the path name
			// of the selected file.
			if (dialog.showDialog () == IFSFileDialog.OK) {
				String s;
				t3.setText(s=dialog.getAbsolutePath ());
				if (s.toUpperCase().indexOf(".CLASS") >=0)
					// Enable Call pushbutton, if selected file is a class
					callPB.setEnabled(true);
				else {
					// if not a class; disable Call pushbutton, and attempt to
					// display contents in JTextarea
					callPB.setEnabled(false);
					document.setSystem(as400Connection);
					ErrorDialogAdapter errorHandler = new ErrorDialogAdapter (parentFrame);
					WorkingCursorAdapter cursorAdapter = new WorkingCursorAdapter (parentFrame);
					document.addErrorListener (errorHandler);
					document.addWorkingListener (cursorAdapter);				
					document.setPath(t3.getText());
					document.load();
					fileStuff.setDocument(document);
				}	
			} else {
				// Clear file, JTextArea, and disable Call pushbutton if user
				// did not select a file.
				t3.setText("");
				fileStuff.setText("");
				callPB.setEnabled(false);
			}
	 		parentFrame.status.setText("Idle.");
		}
	} catch(Exception e1) {}
}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)getLayout()).setConstraints(c, gbc);
	add(c);
}
}
