package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


// This class extends JPanel.  It illustrates the use of JDBC connection
// to retrieve the contents on any AS/400 physical file.  Results are
// displayed on a JTable.


import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableColumn;


public class JDBCManualExample extends JPanel implements 	ActionListener,
																				MouseListener {
private ToolboxDemo		parentFrame;


private JLabel			l1,l2,l3,l4,l5;
private JTextField	t2;
private JTextField	t3=new JTextField("ADTSLAB",11);
private JTextField	t4=new JTextField("PRODDTL",11);


private JTable			table;
private JScrollPane  scrollpane;
private PFTableModel dataModel;
private JTextArea    textArea=new JTextArea();
private JScrollPane  sp=new JScrollPane();
private JScrollPane  spPicture=new JScrollPane();
private JLabel		 picture=null;


private JButton		populatePB=new JButton("Populate");
private JButton		endPB=new JButton("Exit");


public Connection 	alfConnection;





































































public JDBCManualExample(ToolboxDemo t) {
	parentFrame=t;


	t2=new JTextField(parentFrame.AS400Name,9);
	l1=new JLabel("This panel demonstrates how to populate a JTable with the contents of an AS/400 File.");
	l2=new JLabel("AS400:");
	l3=new JLabel("Library:");
	l4=new JLabel("Physical File:");
	dataModel = new PFTableModel();
	table = new JTable(dataModel);
	table.setColumnSelectionAllowed(false);
	table.setToolTipText("This JTable shows the contents of the specified file");
	table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
	scrollpane = new JScrollPane(table);
	scrollpane.setPreferredSize(new Dimension(600, 210));
	scrollpane.setMinimumSize(new Dimension(400, 150));


	sp.setPreferredSize(new Dimension(800, 150));
	sp.setMinimumSize(new Dimension(400, 150));
	sp.getViewport().add(textArea);
	textArea.setToolTipText("Displays AS/400 messages.");


	spPicture.setPreferredSize(new Dimension(200, 150));
	spPicture.setMinimumSize(new Dimension(200, 150));
	spPicture.setToolTipText("Shows picture related to selected row in JTable (ADTSLAB/PRODDTL).");
	spPicture.getViewport().add(picture=(JLabel) makeLabel("ibm.gif"));


	populatePB.addActionListener(this);
	populatePB.setToolTipText("Populate JTable with File contents");
	endPB.addActionListener(this);
	table.addMouseListener(this);


	// Position items on panel
	setLayout(new GridBagLayout());
	addit1(l1,0,0,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l2,1,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l3,1,2,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l4,1,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(t2,3,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(t3,3,2,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(t4,3,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(populatePB,5,2,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(endPB,5,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(spPicture,7,1,1,3,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(scrollpane,0,5,10,7,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(sp,0,13,10,9,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
  }
public void actionPerformed(ActionEvent e) {
	try {
	  if(e.getSource() == populatePB) {
		// Use JDBC connection to populate JTable with files's contents.
		try {
	 		String lib=t3.getText().trim();
	 		String pf=t4.getText().trim();
	 		parentFrame.status.setText("Connecting ....");
			if ((alfConnection == null) || alfConnection.isClosed()) {
				// Load the AS/400 Toolbox for Java JDBC driver.
				Class.forName("com.ibm.as400.access.AS400JDBCDriver");
				alfConnection = DriverManager.getConnection ("jdbc:as400://" + t2.getText().trim() + "/apilib;naming=sql;errors=full;date format=iso");
		   }  				 		
			DatabaseMetaData dmd = alfConnection.getMetaData ();
			Statement select = alfConnection.createStatement ();
	 		parentFrame.status.setText("Retrieving result set ....");
			// form SQL SELECT statement and obtain result set:
	 		ResultSet rs = select.executeQuery ("SELECT * FROM "
												+ lib + dmd.getCatalogSeparator() + pf);


			// retrieve metadata and use to define the table column widths, and
			// headings:
	 		ResultSetMetaData rsmd = rs.getMetaData ();
			int columnCount = rsmd.getColumnCount ();
			String[] columnLabels = new String[columnCount];
			int[] columnWidths = new int[columnCount];
			int tableWidth=0;
			for (int i = 1; i <= columnCount; ++i) {
				columnLabels[i-1] = rsmd.getColumnLabel (i);
				//columnWidths[i-1] = (Math.max (columnLabels[i-1].length(),
				//							  rsmd.getColumnDisplaySize (i))); // *10; // 1.0.1 NLS BUG ???
				columnWidths[i-1] = columnLabels[i-1].length();
				tableWidth+=columnWidths[i-1];
			}
			Object[][] d= new Object[1][columnCount];
			dataModel = new PFTableModel(columnLabels, d);
			table.setModel(dataModel);
			TableColumn tc;
			for (int i=0; i < columnCount; i++) {
				tc=table.getColumn(columnLabels[i]);
				tc.setWidth((int)(columnWidths[i]*scrollpane.getWidth()/tableWidth));
			}
			table.revalidate();
			for (int i = 0; i < columnCount; ++i)
				d[0][i]=" ";
			boolean firstTime=true;
			// update table with result set:
			while (rs.next ()) {
				String[] columnData = new String[columnCount];
				for (int i = 1; i <= columnCount; ++i)
					columnData[i-1] = rs.getString (i);
				if (firstTime)
					for (int i = 0; i < columnCount; ++i)
						dataModel.setValueAt(columnData[i],0,i);
				else
					dataModel.appendRow(columnData);		
				firstTime=false;
		 	}	
			table.revalidate();
		}


		catch (Exception ee) {
			textArea.append("ERROR: " + ee.getMessage()+"\n");
			System.out.println ("ERROR: " + ee.getMessage());
		}
		finally {
			try {
				if (alfConnection != null)
					alfConnection.close ();
			}
			catch (SQLException ee) {
				System.out.println ("ERROR: " + ee.getMessage());
			}
		}
	 	parentFrame.status.setText("Idle.");
	  }
	  if(e.getSource() == endPB) {
		 System.exit(0);
	  }
   } catch(Exception e1) {
	}
}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)getLayout()).setConstraints(c, gbc);
	add(c);
}
private ImageIcon makeImage(String name) {
	String t=LogoExample.class.getResource(name).getPath();
	return new ImageIcon(getToolkit().getImage(t));
}
private JLabel makeLabel(String name) {
	String t=LogoExample.class.getResource(name).getPath();
	ImageIcon image = new ImageIcon(getToolkit().getImage(t));
	textArea.append(t+"\n");
	return new JLabel(image);
}
public void mouseClicked(MouseEvent e)	{
}
public void mouseEntered(MouseEvent e)	{
}
public void mouseExited(MouseEvent e)	{
}
public void mousePressed(MouseEvent e)	{
}
public void mouseReleased(MouseEvent e)	{
	if (e.getSource()==table) {
		// a row has been selected.  If table ADTSLAB/PRODDTL is being displayed;
		// attempt to replace image with the appropriate one.
		String file="";
		if (t4.getText().trim().equalsIgnoreCase("proddtl")) {
			file=(String) table.getValueAt(table.getSelectedRow(),5);
	 		file=file.substring(file.lastIndexOf("/")+1,file.lastIndexOf(".gif")>0?file.lastIndexOf(".gif"):0);
		}
		String f=(file.length() > 0)?file+".gif":"ibm.gif";
		ImageIcon image = makeImage(f);
		picture.setIcon(image);
		picture.updateUI();
	}
}
}
