package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.ibm.as400.access.AS400;
import com.ibm.as400.vaccess.ErrorDialogAdapter;
import com.ibm.as400.vaccess.RecordListTablePane;


public class RI_OExample extends JPanel implements ActionListener{


private ToolboxDemo		parentFrame;


private JLabel			l1,l2,l3,l4,l5;
private JTextField		t1=new JTextField(11);
private JTextField		t2;
private JTextField		t3=new JTextField("adtslab");
private JTextField		t4=new JTextField("customl1");
private JTextField		t5=new JTextField("A");


private RecordListTablePane 	table=new RecordListTablePane();
private PFTableModel	dataModel;
private JTextArea		out=new JTextArea();
private JScrollPane		sp=new JScrollPane();
private JButton			populatePB=new JButton("Retrieve PF");
private JButton			GTPB=new JButton(">");
private JButton			GTEPB=new JButton(">=");
private JButton			LTPB=new JButton("<");
private JButton			LTEPB=new JButton("<=");
private JButton			EPB=new JButton("=");


public AS400 AS400Connection;





































































public RI_OExample(ToolboxDemo t) {
	parentFrame=t;


	t2=new JTextField(parentFrame.AS400Name,9);
	// Initialize JLabels
	l1=new JLabel("This panel demonstrates use of Record I/O Toolbox classes");
	l2=new JLabel("AS400:");
	l3=new JLabel("Library:");
	l4=new JLabel("Physical File:");
	// Set up listeners:
	populatePB.addActionListener(this);
	GTPB.addActionListener(this);
	GTEPB.addActionListener(this);
	LTPB.addActionListener(this);
	LTEPB.addActionListener(this);
	EPB.addActionListener(this);
	// Set up JTable
	dataModel = new PFTableModel();
	sp.setPreferredSize(new Dimension(800, 150));
	sp.setMinimumSize(new Dimension(500, 150));
	sp.getViewport().add(out);
	table.addErrorListener (new ErrorDialogAdapter (parentFrame));
	table.setPreferredSize(new Dimension(400, 210));
	table.setMinimumSize(new Dimension(400, 150));
	//Set up query items:
	JPanel panel1=new JPanel(new GridLayout(1,3));
	panel1.add(new JLabel("First element in key (###, or CHAR):"));
	panel1.add(t5);
	JPanel panelPB=new JPanel(new GridLayout(1,5));
	panelPB.add(LTPB);
	panelPB.add(LTEPB);
	panelPB.add(EPB);
	panelPB.add(GTEPB);
	panelPB.add(GTPB);
	panel1.add(panelPB);
	// Set up tooltip text:
	populatePB.setToolTipText("Retrieve AS/400 file contents and populate JTable");
	table.setToolTipText("JTable displays file/query contents");
	t5.setToolTipText("Enter key value here.");
	GTPB.setToolTipText("Populate JTable with result set from query KEY > key");
	GTEPB.setToolTipText("Populate JTable with result set from query KEY >= key");
	LTPB.setToolTipText("Populate JTable with result set from query KEY < key");
	LTEPB.setToolTipText("Populate JTable with result set from query KEY <= key");
	EPB.setToolTipText("Populate JTable with result set from query KEY = key");
	out.setToolTipText("JTextArea displays messages from AS/400"); 


	// Position items on panel
	setLayout(new GridBagLayout());
	addit1(l1,0,0,6,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l2,1,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(l3,3,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(l4,5,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(t2,2,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(t3,4,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(t4,6,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(populatePB,7,1,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(table,0,5,10,7,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(panel1,0,15,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
//	addit1(panelPB,4,15,6,1,
//		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
//		10,10,1,1,1,1);
	addit1(sp,0,21,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
  }
public void actionPerformed(ActionEvent e) {
	try {
		AS400Connection=new AS400(t2.getText().trim());
 		parentFrame.status.setText("Connecting / Retrieving requested records .....");
		AS400Connection.connectService(AS400.FILE);
		table.setSystem(AS400Connection);
		table.setFileName("/QSYS.LIB/" + t3.getText().trim() +
								".LIB/"+ t4.getText().trim() + ".FILE");
		Object[] key = new Object[1];
		try {
			Integer i1= new Integer(t5.getText().trim());
			key[0] = i1;
		} catch (Exception ee) {
			key[0] = t5.getText().trim();
		}
		table.setKey(key);
		if(e.getSource() == GTPB) {
			table.setKeyed(true);
   			table.setSearchType(RecordListTablePane.KEY_GT);
			table.load();
			table.updateUI();
	  	}
		if(e.getSource() == GTEPB) {
			table.setKeyed(true);
   			table.setSearchType(RecordListTablePane.KEY_GE);
			table.load();
			table.updateUI();
		}
		if(e.getSource() == LTPB) {
			table.setKeyed(true);
   			table.setSearchType(RecordListTablePane.KEY_LT);
			table.load();
			table.updateUI();
		}
		if(e.getSource() == LTEPB) {
			table.setKeyed(true);
   			table.setSearchType(RecordListTablePane.KEY_LE);
			table.load();
			table.updateUI();
		}
		if(e.getSource() == EPB) {
			table.setKeyed(true);
   			table.setSearchType(RecordListTablePane.KEY_EQ);
			table.load();
			table.updateUI();
		}
		if(e.getSource() == populatePB) {
			table.setKeyed(false);
			table.load();
			table.updateUI();
		}
	 	parentFrame.status.setText("Idle.");
   } catch(Exception e1) {
		out.append("ERROR: " + e1.getMessage()+"\n");
	}
}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)getLayout()).setConstraints(c, gbc);
	add(c);
}
}
